// Generated by CoffeeScript 1.10.0
(function() {
  var Content, SearchPath, fs, path,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  path = require('path');

  fs = require('fs');

  Content = (function(superClass) {
    extend(Content, superClass);

    function Content() {
      Content.__super__.constructor.apply(this, arguments);
    }

    return Content;

  })(String);

  SearchPath = (function(superClass) {
    extend(SearchPath, superClass);

    function SearchPath(opts1) {
      var base, base1, ref;
      this.opts = opts1 != null ? opts1 : {};
      if ((base = this.opts).basedir == null) {
        base.basedir = process.cwd();
      }
      if ((base1 = this.opts).encoding == null) {
        base1.encoding = 'utf-8';
      }
      this.opts.exts = (ref = []).concat.apply(ref, this.opts.exts);
      SearchPath.__super__.constructor.apply(this, arguments);
    }

    SearchPath.prototype.exists = function() {
      var i, k, opts, paths, ref, ref1, v;
      paths = 2 <= arguments.length ? slice.call(arguments, 0, i = arguments.length - 1) : (i = 0, []), opts = arguments[i++];
      if (opts == null) {
        opts = {};
      }
      if (!(opts instanceof Object)) {
        paths.push(opts);
        opts = {};
      }
      ref = this.opts;
      for (k in ref) {
        v = ref[k];
        if (opts[k] == null) {
          opts[k] = v;
        }
      }
      return (ref1 = []).concat.apply(ref1, paths).filter(function(f) {
        return (typeof f === 'string') && !!f;
      }).map(function(f) {
        return path.resolve(opts.basedir, f);
      }).filter(function(f) {
        var error, stat;
        try {
          stat = fs.statSync(f);
        } catch (error) {

        }
        switch (false) {
          case !(stat == null):
            return false;
          case !opts.isDirectory:
            return stat.isDirectory();
          case !opts.isFile:
            return stat.isFile();
          default:
            return false;
        }
      });
    };

    SearchPath.prototype.unique = function(key) {
      var i, idx, j, k, output, ref, ref1, results, val, value;
      if (!(this.length > 0)) {
        return this;
      }
      output = {};
      if (key == null) {
        for (key = i = 0, ref = this.length; 0 <= ref ? i < ref : i > ref; key = 0 <= ref ? ++i : --i) {
          output[this[key]] = this[key];
        }
      } else {
        for (k = j = 0, ref1 = this.length - 1; 0 <= ref1 ? j <= ref1 : j >= ref1; k = 0 <= ref1 ? ++j : --j) {
          if (!(typeof this[k] === 'object')) {
            continue;
          }
          val = this[k];
          idx = val[key];
          if (idx == null) {
            idx = typeof val.get === "function" ? val.get(key) : void 0;
          }
          if (idx == null) {
            idx = k;
          }
          if (idx == null) {
            continue;
          }
          output[idx] = val;
        }
      }
      results = [];
      for (key in output) {
        value = output[key];
        results.push(value);
      }
      return results;
    };

    SearchPath.prototype.base = function(path) {
      if (path == null) {
        path = this.opts.basedir;
      }
      this.opts.basedir = path;
      return this;
    };

    SearchPath.prototype.include = function() {
      var dirs, ref;
      dirs = (ref = []).concat.apply(ref, arguments);
      return this.unshift.apply(this, this.unique.call(this.exists(dirs, {
        isDirectory: true
      })));
    };

    SearchPath.prototype.locate = function() {
      var files, ref, res;
      files = (ref = []).concat.apply(ref, arguments);
      res = this.exists(files, {
        isFile: true
      });
      this.unique().forEach((function(_this) {
        return function(dir) {
          return res.push.apply(res, _this.exists(files.map(function(f) {
            return path.resolve(dir, f);
          }), {
            isFile: true
          }));
        };
      })(this));
      return this.unique.call(res);
    };

    SearchPath.prototype.resolve = function() {
      var files, ref;
      files = ((ref = []).concat.apply(ref, arguments)).filter(function(x) {
        return (x != null) && !!x;
      }).reduce(((function(_this) {
        return function(a, b) {
          var ext, i, len, ref;
          a.push(b);
          if (!!!(path.extname(b))) {
            ref = _this.opts.exts;
            for (i = 0, len = ref.length; i < len; i++) {
              ext = ref[i];
              a.push(b + "." + ext);
            }
          }
          return a;
        };
      })(this)), []);
      return this.locate(files);
    };

    SearchPath.prototype.fetch = function() {
      var ref;
      return (this.resolve((ref = []).concat.apply(ref, arguments))).map((function(_this) {
        return function(f) {
          return fs.readFileSync(f, _this.opts.encoding);
        };
      })(this));
    };

    return SearchPath;

  })(Array);

  module.exports = SearchPath;

}).call(this);
